unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Spin;

type              
  TForm1 = class(TForm)
    Image1: TImage;
    Button1: TButton;
    Label1: TLabel;
    SpinEdit1: TSpinEdit;
    procedure Button1Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

const cos30:real=0.866025403;

Var Ecrx, Ecry, etapes : Integer;

procedure segment(x1,y1,x5,y5,count:integer);  //rcursive
var l,x2,x3,x4,y2,y3,y4 : integer;
begin
     l:=round(sqrt(sqr(x5-x1)+sqr(y5-y1)));   //distance P1P5
     if (l<=2) or (count>=etapes) then begin   //condition de sortie
        Form1.Image1.Canvas.MoveTo(x1,y1);
        Form1.Image1.Canvas.LineTo(x5,y5);
     end
     else begin
        x2:=round((2*x1+x5)/3);
        y2:=round((2*y1+y5)/3);
        x4:=round((x1+2*x5)/3);
        y4:=round((y1+2*y5)/3);
        x3:=round(x2/2-cos30*y2+x4/2+cos30*y4);
        y3:=round(cos30*x2+y2/2-cos30*x4+y4/2);
        segment(x1,y1,x2,y2,count+1);
        segment(x2,y2,x3,y3,count+1);
        segment(x3,y3,x4,y4,count+1);
        segment(x4,y4,x5,y5,count+1);
     end;
end;

procedure koch;
var x0,y0,taille:integer;
begin
     Screen.Cursor:=crHourGlass;
     taille:=round(ecrx/2);
     x0:=round(ecrx/4);
     y0:=round(ecry/2-taille*cos30/3);
     segment (x0,y0,x0+taille,y0,0);
     segment (x0+taille,y0,round(x0+taille/2),round(y0+taille*cos30),0);
     segment (round(x0+taille/2),round(y0+taille*cos30),x0,y0,0);
     Screen.Cursor:=crDefault;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
     etapes:=SpinEdit1.Value;
     ecrx:=Image1.Width;
     ecry:=Image1.Height;
     Image1.Canvas.Brush.Color:=clBlack;
     Image1.Canvas.Pen.Color:=clWhite;
     Image1.Canvas.Rectangle(0,0,ecrx,ecry);
     Koch;
end;

end.
